'use strict';

var _Preparer = require('./Normalize-local/Preparer.js');

var _Preparer2 = _interopRequireDefault(_Preparer);

var _Preparer3 = require('./Normalize-URL/Preparer.js');

var _Preparer4 = _interopRequireDefault(_Preparer3);

var _extfs = require('extfs');

var _extfs2 = _interopRequireDefault(_extfs);

var _path = require('path');

var _path2 = _interopRequireDefault(_path);

var _q = require('q');

var _q2 = _interopRequireDefault(_q);

var _colors = require('colors');

var _colors2 = _interopRequireDefault(_colors);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var Normalize = {};
// TODO: Interface in JS ???
Normalize.local = function (pathToEPUBs, options, callback) {

    if (_extfs2.default.isEmptySync(pathToEPUBs)) {
        return _q2.default.reject(new Error('Can`t index empty local: ' + pathToEPUBs));
    }
    // normalize the directory path
    pathToEPUBs = _path2.default.normalize(pathToEPUBs);
    return _Preparer2.default.normalize(pathToEPUBs, options).then(function (dataSet) {
        return callback(dataSet);
    });
};

Normalize.url = function (urlToEpub, callback) {
    return _Preparer4.default.normalize(urlToEpub).then(function (dataSet) {
        return callback(dataSet);
    });
};

Normalize.normalizeEpupTitle = function (title) {

    return _Preparer2.default.normalizeEpupTitle(title);
};

Normalize.normalizeUUID = function (uuid) {

    return _Preparer4.default.normalizeUUID(uuid);
};

module.exports = Normalize;