'use strict';

var _SearchEngine = require('./../SearchEngine');

var _SearchEngine2 = _interopRequireDefault(_SearchEngine);

var _Logger = require('./../Logger');

var _Logger2 = _interopRequireDefault(_Logger);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

module.exports = function (req, res) {

    var beginsWith = req.query['uuid'];
    if (!beginsWith) {
        res.status(500).send('Can`t find query parameter beginsWith -> /deleteFromIndex?uuid=uuid');
        return;
    }

    var uuid = req.query['uuid'];
    _Logger2.default.log('info', 'client request delete -> uuid: ' + uuid);

    if (!uuid) {
        res.status(500).send('Uuid is undefined.');
        return;
    }

    (0, _SearchEngine2.default)({}).then(function (se) {
        se.del(uuid).then(function () {
            res.send('Document with ID ' + uuid + ' deleted.');
            se.close(function (err) {
                if (err) _Logger2.default.log('error', err);
            });
        }).fail(function (err) {
            se.close(function (err) {
                if (err) _Logger2.default.log('error', err);
            });
            _Logger2.default.log('error', err);
            res.send('Somthing goes wrong:  ID ' + uuid);
        });
    }).fail(function (err) {
        _Logger2.default.log('error', err);
    });
};